% NRLDanonimizer: anonymize DICOM images in batch from a directory
%
% Requires MATLAB Image Processing Toolbox. 
%
% Tested on Windows 7, MATLAB 7.11, Image Processing Toolbox 7.1.  
% 
% Usage: put a copy of this script into a directory with DICOM images and
% then run the script in MATLAB.  You may have to rename all of the image
% files first to an extension with .dcm.  To do this, see the first cell
% below.
%
% Output: all the original files have their extension changed to .old with
% all the new ones with extension .dcm; in the final part, you should make 
% the images have the same extension as when they started so to not confuse
% viewer software that may accompany the images
%
% NRLDanonimizer version A1
%
% For a tutorial and an update to this script, see www.nrld.org, technical
% note 3.
%
% ejh 20110428
% NRLD.org

%% rename the non extension files to an appropriate extension
% if the image files are not extensions of *.dcm, use a variation of one of
% the following to rename the files:
%
% !ren *. *.dcm
% !ren *.dicom *.dcm


%% Anonymize images keeping the name the same but with a '1' at the end
clear
clc
% set study and series values, per matlab help
values.StudyInstanceUID = dicomuid;
values.SeriesInstanceUID = dicomuid;
% get filenames
d = dir('*.dcm');
diary('anonymizer_results.txt')
cd
%%
disp(' '),disp(' ')
fprintf('\n # of files: %5.0f,  Processing File:       ',numel(d))
for p = 1:numel(d)
%     pause(.0001)
        if p>10000
            fprintf('\b\b\b\b\b\b%1.0f.',p)
        elseif p>1000
            fprintf('\b\b\b\b\b%1.0f.',p)
        elseif p>100
            fprintf('\b\b\b\b%1.0f.',p)            
        elseif p>10
            fprintf('\b\b\b%1.0f.',p)            
        else
            fprintf('\b\b%1.0f.',p)            
        end
% end
% disp(' ')
% %%
% for p = 1:numel(d)
    try
        dicomanon(d(p).name,sprintf([d(p).name(1:end-3) '1'],p),'update',values);
    catch
        fprintf('\n # of files: %5.0f,  Processing File:       ',numel(d))
        try
            pause(.01)
            dicomanon(d(p).name,sprintf([d(p).name(1:end-3) '1'],p),'update',values);
        catch
            try
                fprintf('\n # of files: %5.0f,  Processing File:       ',numel(d))
                pause(.01)
                dicomanon(d(p).name,sprintf([d(p).name(1:end-3) '1'],p),'update',values);
            catch
                disp('.'),disp(['problem with file ' d(p).name])
                cmdline=['!ren ' d(p).name ' x' d(p).name '.x'];
                eval(cmdline)
                fprintf('\n # of files: %5.0f,  Processing File:       ',numel(d))      
            end
        end
%         !ren *.dcm1 *.temp
    end
end
disp(' '),disp('done')
diary off
%% fix revert
% !del *.dcm1

%% clean up the originals and rename new ones to match
if numel(d)>0
!ren *.dcm *.old
!ren *.1 *.dcm
end

%% to delete 'old' files
% delete('*.old')
